> This is part 1 of 2 of the full documentation (pages 1–100 of 110).
> The content is paginated: fetch every part to see all of it.
> Next part: https://apidocs.d6plus.co.za/llms-full.txt/1
> Page index: https://apidocs.d6plus.co.za/llms.txt

# Getting Started

Hi and welcome!

d6 Integrate provides a RESTful API to interact with the d6+ School Administration and Management System (SAMS).

This API documentation will provide you with everything you need in order to take advantage of the capabilities that d6 Integrate offers.

Please read the entire Getting Started section before diving into the Reference section, as it provides the necessary context and detail you will need to implement an effective integration.

We are always looking to improve, so please email any suggestions to <apidocs@d6.co.za>


# Authorisation & Activation

Each school that makes use of the d6+ SAMS is able the manage the list of integrations they would like to make use of.&#x20;

Before you (our d6 Integrate partner) can interact with a school's data via the d6 Integrate API, the school must first authorise your integration in their d6+ SAMS instance.&#x20;

During your d6 Integrate partner onboarding process, you will receive introductory training on how schools manage their integrations on the d6+ SAMS. This will ensure that you are equipped to assist your new clients to authorise your integration.

This authorisation should ideally only be done once the school has entered into an agreement with you as a service provider, since the school is authorising the sharing of their information with you.

In order keep you updated about which schools are choosing to make use of your service, each time a school authorises or de-authorises your integration, you will receive a notification email. This will be sent to the technical contact email address specified on your d6 Integrate License Agreement.&#x20;

In order to avoid being billed for schools that are not (yet) your client, you have the ability to activate the integration once it has been authorised by the school. This ensures that you retain control over who your active, legitimate clients are. You will need to activate an integration before you are able to interact with the school's data.&#x20;

Billing of a school will only commence after you activate the integration for the first time. Once an integration has been activated, billing will continue for the duration of your license agreement and active subscription, regardless of whether you subsequently de-activate the integration. However, should a school choose to de-authorise your integration, you will no longer be billed for that school.

Please see the [Settings](/reference/settings) section in the Reference area for the relevant API endpoints to view and manage your authorised integrations.

Once a school has authorised your integration and you have activated it, you are free to interact with their data via the the d6 integration API's that are included in your subscription. If you de-activate the integration, or the school de-authorises it, the d6 integration API will not allow access to that school's data.


# API URL

The base URL for all endpoints in this API collection is shown below.

`https://integrate.d6plus.co.za/api/`


# Versioning

d6 Integrate utilises versioning in order to:

* Ensure backward compatibility
* Facilitate feature enhancements and testing
* Manage the deprecation of outdated endpoints
* Ultimately provide a more reliable and consistent user experience for developers

The version number is independent per endpoint.

The version is specified by a number with a ‘v’ prefix (eg: v1, v2) - for example:&#x20;

`https://integrate.d6plus.co.za/api/`**`v1`**`/adminplus/learners`

`https://integrate.d6plus.co.za/api/`**`v3`**`/adminplus/parents`

`https://integrate.d6plus.co.za/api/`**`v2`**`/currplus/learnersubjects`


# Authentication

d6 Integrate requires authentication via username and password credentials which are provided to you by d6 after successful completion of a data sharing license agreement.

The credentials must be passed in the request header using the following parameters:

> HTTP-X-USERNAME
>
> HTTP-X-PASSWORD

{% hint style="warning" %}
All API requests must be made over HTTPS. Requests made over plain HTTP will fail and may risk exposing your key. Your credentials must never be shared. Do not use your credentials in client side code as you may risk exposing it to third parties.
{% endhint %}


# Response Status Codes

d6 Integrate uses status codes that adhere to the HTTP/1.1 standard (RFC 7231):

| Code | Name                  | Description                                                                                               |
| ---- | --------------------- | --------------------------------------------------------------------------------------------------------- |
| 200  | OK                    | The request was successful.                                                                               |
| 400  | Bad Request           | The request was invalid. Normally due to missing or malformed parameters.                                 |
| 401  | Unauthorized          | The server understood the request, but is refusing it.                                                    |
| 403  | Forbidden             | The server understood the request, but access is not allowed.                                             |
| 404  | Not Found             | The resource was not found.                                                                               |
| 429  | Too Many Requests     | Rate limits have been reached, please slow down your requests.                                            |
| 500  | Internal Server Error | Internal server error which has been logged and being attended to. Please try again later.                |
| 501  | Not Implemented       | The server does not support the functionality required to fulfill the request.                            |
| 503  | Service Unavailable   | The server is currently unable to handle the request due to a temporary overload or scheduled maintenance |


# Rate Limiting

Please be aware that should you exceed these limits you will receive a 429 (Too Many Requests).

The current rate limits are:

* 300 requests per 60 seconds per unique IP address


# Errors and Bad Requests

Errors or bad requests caught by the API will always return an appropriate HTTP response as described in the [Response Status Codes](/getting-started/response-status-codes) section, as well as a body containing a JSON object with 2 attributes:

* `error` - The HTTP status name
* `error_description` - A description of the actual problem encountered

The values of these attributes will always be a string.


# Settings

This section details the REST endpoints to interact with the d6 Integrate settings on your account as well as for clients who have authorised your integration.

## Endpoint

The base URL for all endpoints in this module is shown below. The version number is independent per endpoint.

`https://integrate.d6plus.co.za/api/v1/`**`settings`**`/`


# Clients


# Get Clients

## Get the list of clients with integrations authorised

<mark style="color:blue;">`GET`</mark> `https://integrate.d6plus.co.za/api/v1/settings/clients/{school_login_id}`

Use this endpoint to fetch the information of clients who have authorised your integration in their d6+ SAMS instance. By default, all clients with authorised integrations will be returned.&#x20;

It is possible to retrieve the information for a single client by providing the optional `school_login_id` query parameter.

#### Path Parameters

| Name              | Type    | Description                                      |
| ----------------- | ------- | ------------------------------------------------ |
| school\_login\_id | Integer | The login ID of the school to retrieve data from |

#### Headers

| Name                                              | Type   | Description       |
| ------------------------------------------------- | ------ | ----------------- |
| HTTP-X-USERNAME<mark style="color:red;">\*</mark> | String | As provided by d6 |
| HTTP-X-PASSWORD<mark style="color:red;">\*</mark> | String | As provided by d6 |

{% tabs %}
{% tab title="200 The request was successful." %}

```json
[
    {
        "school_login_id": "1000",
        "school_name": "d6+ Primary School",
        "admin_email_address": "support@d6plus.co.za",
        "telephone_calling_code": "27",
        "telephone_number": "0123334444",
        "api_type_id": 8,
        "api_type": "Admin+ API",
        "activated_by_integrator": "No"
    },
    {
        "school_login_id": "1000",
        "school_name": "d6+ Primary School",
        "admin_email_address": "support@d6plus.co.za",
        "telephone_calling_code": "27",
        "telephone_number": "0123334444",
        "api_type_id": 9,
        "api_type": "Curriculum+ API",
        "activated_by_integrator": "Yes"
    }    
]
```

{% endtab %}

{% tab title="404: Not Found The resource was not found." %}

```json
{
    "error": "Not found",
    "error_description": "No client-authorised integrations found"
}
```

{% endtab %}

{% tab title="401: Unauthorized The server understood the request, but access is not allowed." %}

```json
{
    "error": "Unauthorized",
    "error_description": "Request not authorised"
}
```

{% endtab %}
{% endtabs %}

## Examples

{% tabs %}
{% tab title="PHP" %}

```php
<?php

const BASE_URL = 'https://integrate.d6plus.co.za/api/v1/settings/clients';
const API_USERNAME = getenv('API_USERNAME'); // Assuming you have these environment variables set
const API_PASSWORD = getenv('API_PASSWORD');

$curl = curl_init();

$query = http_build_query(PARAMS);

$options = [
    CURLOPT_URL => BASE_URL,
    CURLOPT_RETURNTRANSFER => true,
    CURLOPT_SSL_VERIFYPEER => true,
    CURLOPT_CUSTOMREQUEST => 'GET',
    CURLOPT_HTTPHEADER => [
        "HTTP-X-USERNAME: " . API_USERNAME,
        "HTTP-X-PASSWORD: " . API_PASSWORD
    ],
];

curl_setopt_array($curl, $options);

$response = curl_exec($curl);

if (curl_errno($curl)) {
    throw new Exception('Curl error: ' . curl_error($curl));
}

curl_close($curl);

echo $response;
```

{% endtab %}

{% tab title="cURL" %}

```bash
curl --location 'https://integrate.d6plus.co.za/api/v1/settings/clients' \
--header 'HTTP-X-USERNAME: your_username' \
--header 'HTTP-X-PASSWORD: your_password'
```

{% endtab %}
{% endtabs %}


# Change Client Integration State

## Change the state of the client integration

<mark style="color:purple;">`PATCH`</mark> `https://integrate.d6plus.co.za/api/v1/settings/clients/{school_login_id}`

Use this endpoint to change the state of the integration for a client who has authorised your integration in their d6+ SAMS instance. This state indicates whether you are actively servicing the client or not.

#### Path Parameters

| Name                                                | Type    | Description                                      |
| --------------------------------------------------- | ------- | ------------------------------------------------ |
| school\_login\_id<mark style="color:red;">\*</mark> | Integer | The login ID of the school to retrieve data from |

#### Headers

| Name                                              | Type   | Description       |
| ------------------------------------------------- | ------ | ----------------- |
| HTTP-X-USERNAME<mark style="color:red;">\*</mark> | String | As provided by d6 |
| HTTP-X-PASSWORD<mark style="color:red;">\*</mark> | String | As provided by d6 |

#### Request Body

| Name                                            | Type    | Description                                            |
| ----------------------------------------------- | ------- | ------------------------------------------------------ |
| state<mark style="color:red;">\*</mark>         | Integer | The state you would like to set the integration to     |
| api\_type\_id<mark style="color:red;">\*</mark> | Integer | The api\_type\_id returned by the Get Clients endpoint |

{% tabs %}
{% tab title="200 The request was successful." %}

```json
[]
```

{% endtab %}

{% tab title="404: Not Found The resource was not found." %}

```json
{
    "error": "Not found",
    "error_description": "No client-authorised integrations found"
}
```

{% endtab %}

{% tab title="401: Unauthorized The server understood the request, but access is not allowed." %}

```json
{
    "error": "Unauthorized",
    "error_description": "Client access not authorised for this API type"
}
```

{% endtab %}

{% tab title="500: Internal Server Error The server experienced an error while attempting to perform the requested action." %}

```json
{
    "error": "Internal Server Error",
    "error_description": "Failed to update the integration state"
}
```

{% endtab %}

{% tab title="400: Bad Request The request was invalid. Normally due to missing or malformed parameters." %}

```json
{
    "error": "Bad Request",
    "error_description": "Invalid integration state provided"
}
```

{% endtab %}

{% tab title="204: No Content The request was understood and processed, but no changes were made." %}

```json
[]
```

{% endtab %}
{% endtabs %}

## Examples

{% tabs %}
{% tab title="PHP" %}

```php
<?php

const BASE_URL = 'https://integrate.d6plus.co.za/api/v1/settings/clients';
const SCHOOL_LOGIN_ID = '1000';
const API_USERNAME = getenv('API_USERNAME'); // Assuming you have these environment variables set
const API_PASSWORD = getenv('API_PASSWORD');

$data = [
    "api_type_id" => 8,
    "state" => 1
]; 
$jsonData = json_encode($data);

$curl = curl_init();

$query = http_build_query(PARAMS);

$options = [
    CURLOPT_URL => BASE_URL . '/' . SCHOOL_LOGIN_ID,
    CURLOPT_RETURNTRANSFER => true,
    CURLOPT_SSL_VERIFYPEER => true,
    CURLOPT_CUSTOMREQUEST => 'PATCH',
    CURLOPT_POSTFIELDS => $jsonData,    
    CURLOPT_HTTPHEADER => [
        "HTTP-X-USERNAME: " . API_USERNAME,
        "HTTP-X-PASSWORD: " . API_PASSWORD,
        "Content-Type: application/json",
        "Content-Length: " . strlen($jsonData)        
    ],
];

curl_setopt_array($curl, $options);

$response = curl_exec($curl);

if (curl_errno($curl)) {
    throw new Exception('Curl error: ' . curl_error($curl));
}

curl_close($curl);

echo $response;
```

{% endtab %}

{% tab title="cURL" %}

<pre class="language-bash"><code class="lang-bash"><strong>curl --location --request PATCH 'https://integrate.d6plus.co.za/api/v1/settings/clients/1000' \
</strong>--header 'HTTP-X-USERNAME: YOUR_API_USERNAME' \
--header 'HTTP-X-PASSWORD: YOUR_API_PASSWORD' \
--header 'Content-Type: application/json' \
--data '{"api_type_id": 8, "state": 1}'
</code></pre>

{% endtab %}
{% endtabs %}


# Administration+

This section details the REST endpoints to interact with the Administration+ module.

## Endpoint

The base URL for all endpoints in this module is shown below. The version number is independent per endpoint.

`https://integrate.d6plus.co.za/api/v1/`**`adminplus`**`/`


# Lookups

A number of the API endpoints return values for attributes which are list items in d6+, for example a language or grade, which can be selected from a dropdown in d6+. In order to manage and facilitate these attributes more effectively, there are a number of endpoints available to lookup one or all of the available values in the list.

Some of these lists are generic across all schools, but some can be customised per school, in which case it will be necessary to specify the desired school's Login ID in the request URL, as illustrated in the relevant endpoint documentation.


# Ethnic Group(s)

## Get the list of available ethnic groups

<mark style="color:blue;">`GET`</mark> `https://integrate.d6plus.co.za/api/v1/adminplus/lookup/ethnicgroup/{ethnic_group_id}`

Use this endpoint to retrieve the list of available ethnic groups within the d6+ SAMS. The list is generic across all d6+ SAMS clients. By default all available ethnic groups are returned.&#x20;

It is possible to retrieve the information for a single ethnic group by providing the optional `ethnic_group_id` query parameter.

#### Path Parameters

| Name              | Type    | Description                            |
| ----------------- | ------- | -------------------------------------- |
| ethnic\_group\_id | Integer | The ID of the ethnic group to retrieve |

#### Headers

| Name                                              | Type   | Description       |
| ------------------------------------------------- | ------ | ----------------- |
| HTTP-X-USERNAME<mark style="color:red;">\*</mark> | String | As provided by d6 |
| HTTP-X-PASSWORD<mark style="color:red;">\*</mark> | String | As provided by d6 |

{% tabs %}
{% tab title="200 The request was successful." %}

```json
[
    {
        "id": "1",
        "name": "African/Black"
    },
    {
        "id": "2",
        "name": "Coloured"
    },
    {
        "id": "3",
        "name": "Indian"
    },
    {
        "id": "4",
        "name": "White"
    },
    {
        "id": "5",
        "name": "Other"
    },
    {
        "id": "6",
        "name": "Asian"
    }
]
```

{% endtab %}

{% tab title="404: Not Found The resource was not found." %}

```json
{
    "error": "Not found",
    "error_description": "No ethnic group(s) found"
}
```

{% endtab %}

{% tab title="401: Unauthorized The server understood the request, but access is not allowed." %}

```json
{
    "error": "Unauthorized",
    "error_description": "Request not authorised"
}
```

{% endtab %}
{% endtabs %}

## Examples

{% tabs %}
{% tab title="PHP" %}

```php
<?php

const BASE_URL = 'https://integrate.d6plus.co.za/api/v1/adminplus/lookup/ethnicgroup';
const ETHNIC_GROUP_ID = '1';

const API_USERNAME = getenv('API_USERNAME'); // Assuming you have these environment variables set
const API_PASSWORD = getenv('API_PASSWORD');

$curl = curl_init();

$options = [
    CURLOPT_URL => BASE_URL . '/' . ETHNIC_GROUP_ID,
    CURLOPT_RETURNTRANSFER => true,
    CURLOPT_SSL_VERIFYPEER => true,
    CURLOPT_CUSTOMREQUEST => 'GET',
    CURLOPT_HTTPHEADER => [
        "HTTP-X-USERNAME: " . API_USERNAME,
        "HTTP-X-PASSWORD: " . API_PASSWORD
    ],
];

curl_setopt_array($curl, $options);

$response = curl_exec($curl);

if (curl_errno($curl)) {
    throw new Exception('Curl error: ' . curl_error($curl));
}

curl_close($curl);

echo $response;
```

{% endtab %}

{% tab title="cURL" %}

```bash
curl --location 'https://integrate.d6plus.co.za/api/v1/adminplus/lookup/ethnicgroup/1' \
--header 'HTTP-X-USERNAME: your_username' \
--header 'HTTP-X-PASSWORD: your_password'
```

{% endtab %}
{% endtabs %}


# Genders

## Get the list of available genders

<mark style="color:blue;">`GET`</mark> `https://integrate.d6plus.co.za/api/v1/adminplus/lookup/genders`

Use this endpoint to retrieve the list of available genders within the d6+ SAMS. The list is generic across all d6+ SAMS clients. All available genders are returned.&#x20;

#### Headers

| Name                                              | Type   | Description       |
| ------------------------------------------------- | ------ | ----------------- |
| HTTP-X-USERNAME<mark style="color:red;">\*</mark> | String | As provided by d6 |
| HTTP-X-PASSWORD<mark style="color:red;">\*</mark> | String | As provided by d6 |

{% tabs %}
{% tab title="200 The request was successful." %}

```json
[
    {
        "id": "M",
        "name": "Male"
    },
    {
        "id": "F",
        "name": "Female"
    }
]
```

{% endtab %}

{% tab title="401: Unauthorized The server understood the request, but access is not allowed." %}

```json
{
    "error": "Unauthorized",
    "error_description": "Request not authorised"
}
```

{% endtab %}
{% endtabs %}

## Examples

{% tabs %}
{% tab title="PHP" %}

```php
<?php

const BASE_URL = 'https://integrate.d6plus.co.za/api/v1/adminplus/lookup/genders';

const API_USERNAME = getenv('API_USERNAME'); // Assuming you have these environment variables set
const API_PASSWORD = getenv('API_PASSWORD');

$curl = curl_init();

$options = [
    CURLOPT_URL => BASE_URL,
    CURLOPT_RETURNTRANSFER => true,
    CURLOPT_SSL_VERIFYPEER => true,
    CURLOPT_CUSTOMREQUEST => 'GET',
    CURLOPT_HTTPHEADER => [
        "HTTP-X-USERNAME: " . API_USERNAME,
        "HTTP-X-PASSWORD: " . API_PASSWORD
    ],
];

curl_setopt_array($curl, $options);

$response = curl_exec($curl);

if (curl_errno($curl)) {
    throw new Exception('Curl error: ' . curl_error($curl));
}

curl_close($curl);

echo $response;
```

{% endtab %}

{% tab title="cURL" %}

```bash
curl --location 'https://integrate.d6plus.co.za/api/v1/adminplus/lookup/genders' \
--header 'HTTP-X-USERNAME: your_username' \
--header 'HTTP-X-PASSWORD: your_password'
```

{% endtab %}
{% endtabs %}


# Grade(s)

## Get the list of available grades

<mark style="color:blue;">`GET`</mark> `https://integrate.d6plus.co.za/api/v1/adminplus/lookup/grade/{school_login_id}`

Use this endpoint to retrieve the list of available grades within the d6+ SAMS.&#x20;

The list is not generic across all d6+ SAMS clients, and could be customised per school. This endpoint allows you to specify a school Login ID in order to retrieve the list of grades offered by the school, along with their potentially customised names.&#x20;

By default all available grades are returned.&#x20;

It is also possible to retrieve the information for a single grade by providing the optional `grade_id` query parameter.

#### Path Parameters

| Name                                                | Type    | Description                                      |
| --------------------------------------------------- | ------- | ------------------------------------------------ |
| school\_login\_id<mark style="color:red;">\*</mark> | Integer | The login ID of the school to retrieve data from |

#### Query Parameters

| Name      | Type   | Description                |
| --------- | ------ | -------------------------- |
| grade\_id | String | The ID of a specific grade |

#### Headers

| Name                                              | Type   | Description       |
| ------------------------------------------------- | ------ | ----------------- |
| HTTP-X-USERNAME<mark style="color:red;">\*</mark> | String | As provided by d6 |
| HTTP-X-PASSWORD<mark style="color:red;">\*</mark> | String | As provided by d6 |

{% tabs %}
{% tab title="200 The request was successful." %}

```json
[
    {
        "id": "1",
        "name": "Grade RR"
    },
    {
        "id": "2",
        "name": "Grade R"
    },
    {
        "id": "3",
        "name": "Grade 1"
    },
    {
        "id": "4",
        "name": "Grade 2"
    },
    {
        "id": "5",
        "name": "Grade 3"
    },
    {
        "id": "6",
        "name": "Grade 4"
    },
    {
        "id": "7",
        "name": "Grade 5"
    },
    {
        "id": "8",
        "name": "Grade 6"
    }
]
```

{% endtab %}

{% tab title="404: Not Found The resource was not found." %}

```json
{
    "error": "Not found",
    "error_description": "No grade(s) found"
}
```

{% endtab %}

{% tab title="401: Unauthorized The server understood the request, but access is not allowed." %}

```json
{
    "error": "Unauthorized",
    "error_description": "Request not authorised"
}
```

{% endtab %}
{% endtabs %}

## Examples

{% tabs %}
{% tab title="PHP" %}

```php
<?php

const BASE_URL = 'https://integrate.d6plus.co.za/api/v1/adminplus/lookup/grade';
const SCHOOL_LOGIN_ID = '1000';
const PARAMS = [
    'grade_id' => 1
    ];

const API_USERNAME = getenv('API_USERNAME'); // Assuming you have these environment variables set
const API_PASSWORD = getenv('API_PASSWORD');

$curl = curl_init();

$query = http_build_query(PARAMS);

$options = [
    CURLOPT_URL => BASE_URL . '/' . SCHOOL_LOGIN_ID . '?' . $query,
    CURLOPT_RETURNTRANSFER => true,
    CURLOPT_SSL_VERIFYPEER => true,
    CURLOPT_CUSTOMREQUEST => 'GET',
    CURLOPT_HTTPHEADER => [
        "HTTP-X-USERNAME: " . API_USERNAME,
        "HTTP-X-PASSWORD: " . API_PASSWORD
    ],
];

curl_setopt_array($curl, $options);

$response = curl_exec($curl);

if (curl_errno($curl)) {
    throw new Exception('Curl error: ' . curl_error($curl));
}

curl_close($curl);

echo $response;
```

{% endtab %}

{% tab title="cURL" %}

```bash
curl --location 'https://integrate.d6plus.co.za/api/v1/adminplus/lookup/grade/1000?grade_id=1' \
--header 'HTTP-X-USERNAME: your_username' \
--header 'HTTP-X-PASSWORD: your_password'
```

{% endtab %}
{% endtabs %}


# Language(s)

## Get the list of available languages

<mark style="color:blue;">`GET`</mark> `https://integrate.d6plus.co.za/api/v1/adminplus/lookup/language/{language_id}`

Use this endpoint to retrieve the list of available languages within the d6+ SAMS. The list is generic across all d6+ SAMS clients. By default all available languages are returned.&#x20;

It is possible to retrieve the information for a single languages by providing the optional `language_id` query parameter.

#### Path Parameters

| Name         | Type    | Description                        |
| ------------ | ------- | ---------------------------------- |
| language\_id | Integer | The ID of the language to retrieve |

#### Headers

| Name                                              | Type   | Description       |
| ------------------------------------------------- | ------ | ----------------- |
| HTTP-X-USERNAME<mark style="color:red;">\*</mark> | String | As provided by d6 |
| HTTP-X-PASSWORD<mark style="color:red;">\*</mark> | String | As provided by d6 |

{% tabs %}
{% tab title="200 The request was successful." %}

```json
[
    {
        "id": "1",
        "name": "Afrikaans"
    },
    {
        "id": "2",
        "name": "English"
    },
    {
        "id": "3",
        "name": "Ndebele"
    },
    {
        "id": "4",
        "name": "Swazi"
    },
    {
        "id": "5",
        "name": "Xhosa"
    }
]
```

{% endtab %}

{% tab title="404: Not Found The resource was not found." %}

```json
{
    "error": "Not found",
    "error_description": "No language(s) found"
}
```

{% endtab %}

{% tab title="401: Unauthorized The server understood the request, but access is not allowed." %}

```json
{
    "error": "Unauthorized",
    "error_description": "Request not authorised"
}
```

{% endtab %}
{% endtabs %}

## Examples

{% tabs %}
{% tab title="PHP" %}

```php
<?php

const BASE_URL = 'https://integrate.d6plus.co.za/api/v1/adminplus/lookup/language';
const LANGUAGE_ID = '1';

const API_USERNAME = getenv('API_USERNAME'); // Assuming you have these environment variables set
const API_PASSWORD = getenv('API_PASSWORD');

$curl = curl_init();

$options = [
    CURLOPT_URL => BASE_URL . '/' . LANGUAGE_ID,
    CURLOPT_RETURNTRANSFER => true,
    CURLOPT_SSL_VERIFYPEER => true,
    CURLOPT_CUSTOMREQUEST => 'GET',
    CURLOPT_HTTPHEADER => [
        "HTTP-X-USERNAME: " . API_USERNAME,
        "HTTP-X-PASSWORD: " . API_PASSWORD
    ],
];

curl_setopt_array($curl, $options);

$response = curl_exec($curl);

if (curl_errno($curl)) {
    throw new Exception('Curl error: ' . curl_error($curl));
}

curl_close($curl);

echo $response;
```

{% endtab %}

{% tab title="cURL" %}

```bash
curl --location 'https://integrate.d6plus.co.za/api/v1/adminplus/lookup/language/1' \
--header 'HTTP-X-USERNAME: your_username' \
--header 'HTTP-X-PASSWORD: your_password'
```

{% endtab %}
{% endtabs %}


# Marital Status(')

## Get the list of available marital status'

<mark style="color:blue;">`GET`</mark> `https://integrate.d6plus.co.za/api/v1/adminplus/lookup/maritalstatus/{marital_status_id}`

Use this endpoint to retrieve the list of available marital status' within the d6+ SAMS. The list is generic across all d6+ SAMS clients. By default all available marital status' are returned.&#x20;

It is possible to retrieve the information for a single marital status by providing the optional `marital_status_id` query parameter.

#### Path Parameters

| Name                | Type    | Description                              |
| ------------------- | ------- | ---------------------------------------- |
| marital\_status\_id | Integer | The ID of the marital status to retrieve |

#### Headers

| Name                                              | Type   | Description       |
| ------------------------------------------------- | ------ | ----------------- |
| HTTP-X-USERNAME<mark style="color:red;">\*</mark> | String | As provided by d6 |
| HTTP-X-PASSWORD<mark style="color:red;">\*</mark> | String | As provided by d6 |

{% tabs %}
{% tab title="200 The request was successful." %}

```json
[
    {
        "id": "1",
        "name": "Divorced"
    },
    {
        "id": "2",
        "name": "Married"
    },
    {
        "id": "3",
        "name": "Single"
    },
    {
        "id": "4",
        "name": "Widowed"
    },
    {
        "id": "6",
        "name": "Separated"
    },
    {
        "id": "7",
        "name": "Common law marriage"
    }
]
```

{% endtab %}

{% tab title="404: Not Found The resource was not found." %}

```json
{
    "error": "Not found",
    "error_description": "No marital status' found"
}
```

{% endtab %}

{% tab title="401: Unauthorized The server understood the request, but access is not allowed." %}

```json
{
    "error": "Unauthorized",
    "error_description": "Request not authorised"
}
```

{% endtab %}
{% endtabs %}

## Examples

{% tabs %}
{% tab title="PHP" %}

```php
<?php

const BASE_URL = 'https://integrate.d6plus.co.za/api/v1/adminplus/lookup/maritalstatus';
const MARITAL_STATUS_ID = '1';

const API_USERNAME = getenv('API_USERNAME'); // Assuming you have these environment variables set
const API_PASSWORD = getenv('API_PASSWORD');

$curl = curl_init();

$options = [
    CURLOPT_URL => BASE_URL . '/' . MARITAL_STATUS_ID,
    CURLOPT_RETURNTRANSFER => true,
    CURLOPT_SSL_VERIFYPEER => true,
    CURLOPT_CUSTOMREQUEST => 'GET',
    CURLOPT_HTTPHEADER => [
        "HTTP-X-USERNAME: " . API_USERNAME,
        "HTTP-X-PASSWORD: " . API_PASSWORD
    ],
];

curl_setopt_array($curl, $options);

$response = curl_exec($curl);

if (curl_errno($curl)) {
    throw new Exception('Curl error: ' . curl_error($curl));
}

curl_close($curl);

echo $response;
```

{% endtab %}

{% tab title="cURL" %}

```bash
curl --location 'https://integrate.d6plus.co.za/api/v1/adminplus/lookup/maritalstatus/1' \
--header 'HTTP-X-USERNAME: your_username' \
--header 'HTTP-X-PASSWORD: your_password'
```

{% endtab %}
{% endtabs %}


# School


# Get School Info

## Get the school information

<mark style="color:blue;">`GET`</mark> `https://integrate.d6plus.co.za/api/v1/adminplus/school/{school_login_id}`

Use this endpoint to fetch the information for the specified school.

#### Path Parameters

| Name                                                | Type    | Description                                      |
| --------------------------------------------------- | ------- | ------------------------------------------------ |
| school\_login\_id<mark style="color:red;">\*</mark> | Integer | The login ID of the school to retrieve data from |

#### Headers

| Name                                              | Type   | Description       |
| ------------------------------------------------- | ------ | ----------------- |
| HTTP-X-USERNAME<mark style="color:red;">\*</mark> | String | As provided by d6 |
| HTTP-X-PASSWORD<mark style="color:red;">\*</mark> | String | As provided by d6 |

{% tabs %}
{% tab title="200 The request was successful." %}

```json
{
    "school_name": "d6+ Primary School",
    "admin_email_address": "support@d6plus.co.za",
    "telephone_calling_code": "27",
    "telephone_number": "0123334444",
    "website": "https://d6.co.za/",
    "physical_address": "Pegasus Building 1, 3rd Floor\r\nMercy Avenue\r\nWaterkloof Glen Ext 2
\r\nPretoria",
    "quantile": "4",
    "medium": "Dual medium",
    "emis_number": "999999999",
    "country": "South Africa",
    "province": "Gauteng",
    "tuition_languages": [
        "Afrikaans",
        "English"
    ]
}
```

{% endtab %}

{% tab title="404: Not Found The resource was not found." %}

```json
{
    "error": "Not found",
    "error_description": "No school record found"
}
```

{% endtab %}

{% tab title="401: Unauthorized The server understood the request, but access is not allowed." %}

```json
{
    "error": "Unauthorized",
    "error_description": "Client access not authorised"
}
```

{% endtab %}

{% tab title="403: Forbidden The server understood the request, but the requested action is not allowed." %}

```json
{
    "error": "Integration not activated",
    "error_description": "Please activate the Admin+ API for this client before making this request"
}
```

{% endtab %}
{% endtabs %}

## Examples

{% tabs %}
{% tab title="PHP" %}

```php
<?php

const BASE_URL = 'https://integrate.d6plus.co.za/api/v1/adminplus/school';
const SCHOOL_LOGIN_ID = '1000';

const API_USERNAME = getenv('API_USERNAME'); // Assuming you have these environment variables set
const API_PASSWORD = getenv('API_PASSWORD');

$curl = curl_init();

$options = [
    CURLOPT_URL => BASE_URL . '/' . SCHOOL_LOGIN_ID,
    CURLOPT_RETURNTRANSFER => true,
    CURLOPT_SSL_VERIFYPEER => true,
    CURLOPT_CUSTOMREQUEST => 'GET',
    CURLOPT_HTTPHEADER => [
        "HTTP-X-USERNAME: " . API_USERNAME,
        "HTTP-X-PASSWORD: " . API_PASSWORD
    ],
];

curl_setopt_array($curl, $options);

$response = curl_exec($curl);

if (curl_errno($curl)) {
    throw new Exception('Curl error: ' . curl_error($curl));
}

curl_close($curl);

echo $response;
```

{% endtab %}

{% tab title="cURL" %}

```bash
curl --location 'https://integrate.d6plus.co.za/api/v1/adminplus/school/1000' \
--header 'HTTP-X-USERNAME: your_username' \
--header 'HTTP-X-PASSWORD: your_password'
```

{% endtab %}
{% endtabs %}


# Learner


# Get Learner(s)

## Get one or more learner records

<mark style="color:blue;">`GET`</mark> `https://integrate.d6plus.co.za/api/v1/adminplus/learners/{school_login_id}`

Use this endpoint to fetch one or more learner records for the specified school.  By default, all current enrolled learners will be returned.&#x20;

It is possible to retrieve non-current learners by providing the optional `status` query parameter. &#x20;

When retrieving left learners, additional optional `since` and `until` query parameters will allow you to specify a date range, and only learners who have left in this date range will be returned. By default, learners who have left in the last month will be returned. The `since` - `until` range may not be more than 1 year.

It is possible to retrieve a single learner by providing the optional `learner_id` query parameter.&#x20;

It is possible to retrieve the learners for a specific grade or grades, by providing the optional `grade_id` query parameter. This can be a single grade ID or a comma-separated list of grade ID's. The list of available grade ID's for a school can be obtained by making use of the [Grade(s) Lookup](/reference/administration+/lookups/grade-s) endpoint.&#x20;

If your subscription includes the Parent API, it is possible to include the parent/guardian data directly in the learner response payload by providing the optional `include_parents` query parameter. The parent/guardian data will be included in a sub-array per learner, with  parent/guardian 1 followed by parent/guardian 2.

#### Path Parameters

| Name                                                | Type    | Description                                      |
| --------------------------------------------------- | ------- | ------------------------------------------------ |
| school\_login\_id<mark style="color:red;">\*</mark> | Integer | The login ID of the school to retrieve data from |

#### Query Parameters

| Name             | Type    | Description                                                                                                                                                                                 |
| ---------------- | ------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| status           | String  | <p>The status of the learners to return. Acceptable values are:<br>\* current (default)<br>\* left<br>\* waitlist</p>                                                                       |
| since            | String  | The date to which left learner transfer dates should be limited, when using the `status` parameter. Defaults to 1 month ago. May not be more than 1 year before `until`. Format: YYYY-MM-DD |
| until            | String  | The date until which left learner transfer dates should be limited, when using the `status` parameter. Defaults to today. May not be more than 1 year after `since`. Format: YYYY-MM-DD     |
| learner\_id      | Integer | The ID of a specific learner                                                                                                                                                                |
| grade\_id        | Integer | A comma-separated list of grade ID's to filter by                                                                                                                                           |
| include\_parents | String  | Whether to include the parent data in the response                                                                                                                                          |
| name             | String  | Search for a learner by their name, surname or name and surname combination                                                                                                                 |
| family\_code     | Integer | Search for a learner(s) by their family code                                                                                                                                                |

#### Headers

| Name                                              | Type   | Description       |
| ------------------------------------------------- | ------ | ----------------- |
| HTTP-X-USERNAME<mark style="color:red;">\*</mark> | String | As provided by d6 |
| HTTP-X-PASSWORD<mark style="color:red;">\*</mark> | String | As provided by d6 |

{% tabs %}
{% tab title="200 The request was successful." %}

```json
[
    {
        "id": "1",
        "first_name": "John",
        "last_name": "Smith",
        "mobile_calling_code": "27",
        "mobile_number": "0823456789",
        "email_address": "jsmith@example.com",
        "date_of_birth": "2018-01-01",
        "gender": "M",
        "ethnic_group_id": "4",
        "ethnic_group": "White",        
        "home_language_id": "1",
        "home_language": "Afrikaans",
        "tuition_language_id": "1",        
        "tuition_language": "Afrikaans",
        "nationality": "South Africa",
        "admission_number": "12345",
        "family_code": "1001",
        "id_number": "1801015005084",
        "passport_number": "",
        "grade_id": "9",
        "grade": "7",
        "register_class_name": "5A",
        "register_class_teacher_id": "4",
        "country": "South Africa",
        "province": "Gauteng",        
        "education_stream": "Mainstream",
        "photo_url": "",
        "parent1_id": "40",
        "parent2_id": "41",
        "parents": [
            {
                "id": "40",
                "title": "Mr",
                "first_name": "John James",
                "last_name": "Smith",
                "mobile_calling_code": "27",
                "mobile_number": "0823456789",
                "email_address": "jjsmith@example.com",
                "date_of_birth": "1967-02-14",
                "gender": "M",
                "ethnic_group_id": "4",
                "ethnic_group": "White",
                "residential_address": "Plot 101\r\nDaffodil Street\r\nPretoria",
                "postal_address": "PO Box 12\r\nMenlyn\r\nPretoria",
                "home_language_id": "2",                
                "home_language": "English",
                "nationality": "South Africa",
                "family_code": "1001",
                "id_number": "6702145076084",
                "passport_number": "A0176543",
                "marital_status_id": "2",
                "marital_status": "Married",                
                "occupation_status": "Full Time Employed",
                "occupation": "Salesman",
                "employment_sector": "Selling",
                "gross_annual_income": "120000.00"            
            },
            {
                "id": "41",
                "title": "Mrs",
                "first_name": "Jane Jenny",
                "last_name": "Smith",
                "mobile_calling_code": "27",
                "mobile_number": "0798765432",
                "email_address": "smith.jj@example.org",
                "date_of_birth": "1955-06-17",
                "gender": "F",
                "ethnic_group_id": "1",                
                "ethnic_group": "African/Black",
                "residential_address": "Plot 101\r\nDaffodil Street\r\nPretoria",
                "postal_address": "PO Box 12\r\nMenlyn\r\nPretoria",
                "home_language_id": "2",                
                "home_language": "English",
                "nationality": "South Africa",
                "family_code": "1001",
                "id_number": "5506170079082",
                "passport_number": "",
                "marital_status_id": "2",
                "marital_status": "Married",                
                "occupation_status": "Unemployed",
                "occupation": "",
                "employment_sector": "Other",
                "gross_annual_income": "0.00"            
            }
        ]
    },
    {
        "id": "2",
        "first_name": "Jane",
        "last_name": "Doe",
        "mobile_calling_code": "27",
        "mobile_number": "0798765432",
        "email_address": "jane@example.org",
        "date_of_birth": "2018-06-13",
        "gender": "F",
        "ethnic_group_id": "1",
        "ethnic_group": "African/Black",
        "home_language_id": "1",        
        "home_language": "Afrikaans",
        "tuition_language_id": "1",        
        "tuition_language": "Afrikaans",
        "nationality": "South Africa",
        "admission_number": "12346",
        "family_code": "1001",
        "id_number": "1806130110087",
        "passport_number": "",
        "grade_id": "7",        
        "grade": "5",
        "register_class_name": "4C",
        "register_class_teacher_id": "13"
        "country": "South Africa",
        "province": "Gauteng",        
        "education_stream": "Mainstream",
        "photo_url": "",
        "parent1_id": "40",
        "parent2_id": "41",
        "parents": [
            {
                "id": "40",
                "title": "Mr",
                "first_name": "John James",
                "last_name": "Smith",
                "mobile_calling_code": "27",
                "mobile_number": "0823456789",
                "email_address": "jjsmith@example.com",
                "date_of_birth": "1967-02-14",
                "gender": "M",
                "ethnic_group_id": "4",                
                "ethnic_group": "White",
                "residential_address": "Plot 101\r\nDaffodil Street\r\nPretoria",
                "postal_address": "PO Box 12\r\nMenlyn\r\nPretoria",
                "home_language_id": "2",                
                "home_language": "English",
                "nationality": "South Africa",
                "family_code": "1001",
                "id_number": "6702145076084",
                "passport_number": "A0176543",
                "marital_status_id": "2",
                "marital_status": "Married",
                "occupation_status": "Full Time Employed",
                "occupation": "Salesman",
                "employment_sector": "Selling",
                "gross_annual_income": "120000.00"            
            },
            {
                "id": "41",
                "title": "Mrs",
                "first_name": "Jane Jenny",
                "last_name": "Smith",
                "mobile_calling_code": "27",
                "mobile_number": "0798765432",
                "email_address": "smith.jj@example.org",
                "date_of_birth": "1955-06-17",
                "gender": "F",
                "ethnic_group_id": "1",                
                "ethnic_group": "African/Black",
                "residential_address": "Plot 101\r\nDaffodil Street\r\nPretoria",
                "postal_address": "PO Box 12\r\nMenlyn\r\nPretoria",
                "home_language_id": "2",                
                "home_language": "English",
                "nationality": "South Africa",
                "family_code": "1001",
                "id_number": "5506170079082",
                "passport_number": "",
                "marital_status_id": "2",
                "marital_status": "Married",
                "occupation_status": "Unemployed",
                "occupation": "",
                "employment_sector": "Other",
                "gross_annual_income": "0.00"            
            }
        ]
    }
]
```

{% endtab %}

{% tab title="404: Not Found The resource was not found." %}

```json
{
    "error": "Not found",
    "error_description": "No learner records found"
}
```

{% endtab %}

{% tab title="401: Unauthorized The server understood the request, but is refusing it or access is not allowed." %}

```json
{
    "error": "Unauthorized",
    "error_description": "Client access not authorised"
}
```

{% endtab %}

{% tab title="403: Forbidden The server understood the request, but the requested action is not allowed." %}

```json
{
    "error": "Integration not activated",
    "error_description": "Please activate the Admin+ API for this client before making this request"
}
```

{% endtab %}
{% endtabs %}

## Examples

{% tabs %}
{% tab title="PHP" %}

```php
<?php

const BASE_URL = 'https://integrate.d6plus.co.za/api/v1/adminplus/learners';
const SCHOOL_LOGIN_ID = '1000';
const PARAMS = [
    'learner_id' => 1, 
    'include_parents' => 1
    ];
const API_USERNAME = getenv('API_USERNAME'); // Assuming you have these environment variables set
const API_PASSWORD = getenv('API_PASSWORD');

$curl = curl_init();

$query = http_build_query(PARAMS);

$options = [
    CURLOPT_URL => BASE_URL . '/' . SCHOOL_LOGIN_ID . '?' . $query,
    CURLOPT_RETURNTRANSFER => true,
    CURLOPT_SSL_VERIFYPEER => true,
    CURLOPT_CUSTOMREQUEST => 'GET',
    CURLOPT_HTTPHEADER => [
        "HTTP-X-USERNAME: " . API_USERNAME,
        "HTTP-X-PASSWORD: " . API_PASSWORD
    ],
];

curl_setopt_array($curl, $options);

$response = curl_exec($curl);

if (curl_errno($curl)) {
    throw new Exception('Curl error: ' . curl_error($curl));
}

curl_close($curl);

echo $response;
```

{% endtab %}

{% tab title="cURL" %}

```bash
curl --location 'https://integrate.d6plus.co.za/api/v1/adminplus/learners/1000?learner_id=1&include_parents=1' \
--header 'HTTP-X-USERNAME: your_username' \
--header 'HTTP-X-PASSWORD: your_password'
```

{% endtab %}
{% endtabs %}


# Get Learner Absentees

## Get learner absentee records

<mark style="color:blue;">`GET`</mark> `https://integrate.d6plus.co.za/api/v1/adminplus/learnerabsentees/{school_login_id}`

Use this endpoint to fetch absentee records for one or more learners for the specified school.  By default, all absentee records for the last month will be returned, regardless of the associated learners current status.

It is possible to retrieve absentee records for a single learner by providing the optional `learner_id` query parameter.

It is possible to specify a different date range by providing the optional `from_date` and `to_date` query parameters. \
The following validation applies:\
\- The `to_date` may not be before the `from_date`. \
\- The date range may not span more than 31 days.

#### Path Parameters

| Name                                                | Type    | Description                                      |
| --------------------------------------------------- | ------- | ------------------------------------------------ |
| school\_login\_id<mark style="color:red;">\*</mark> | Integer | The login ID of the school to retrieve data from |

#### Query Parameters

| Name        | Type    | Description                           |
| ----------- | ------- | ------------------------------------- |
| learner\_id | Integer | The ID of a specific learner          |
| to\_date    | String  | Range end date in format YYYY-MM-DD   |
| from\_date  | String  | Range start date in format YYYY-MM-DD |

#### Headers

| Name                                              | Type   | Description       |
| ------------------------------------------------- | ------ | ----------------- |
| HTTP-X-USERNAME<mark style="color:red;">\*</mark> | String | As provided by d6 |
| HTTP-X-PASSWORD<mark style="color:red;">\*</mark> | String | As provided by d6 |

{% tabs %}
{% tab title="200 The request was successful." %}

```json
[
    {
        "id": "399910",
        "learner_id": "6273",
        "absent_date": "2023-06-01",
        "absent_reason": "Illness"
    },
    {
        "id": "399912",
        "learner_id": "6273",
        "absent_date": "2023-06-02",
        "absent_reason": "Illness"
    }
]
```

{% endtab %}

{% tab title="404: Not Found The resource was not found." %}

```json
{
    "error": "Not found",
    "error_description": "No learner absentee records found"
}
```

{% endtab %}

{% tab title="401: Unauthorized The server understood the request, but is refusing it or access is not allowed." %}

```json
{
    "error": "Unauthorized",
    "error_description": "Client access not authorised"
}
```

{% endtab %}

{% tab title="400: Bad Request The request was invalid. Normally due to missing or malformed parameters." %}

```json
{
    "error": "Bad Request",
    "error_description": "The specified date range may not be more than 31 days"
}
```

{% endtab %}

{% tab title="403: Forbidden The server understood the request, but the requested action is not allowed." %}

```json
{
    "error": "Integration not activated",
    "error_description": "Please activate the Admin+ API for this client before making this request"
}
```

{% endtab %}
{% endtabs %}

## Examples

{% tabs %}
{% tab title="PHP" %}

```php
<?php

const BASE_URL = 'https://integrate.d6plus.co.za/api/v1/adminplus/learnerabsentees';
const SCHOOL_LOGIN_ID = '1000';
const PARAMS = [
    'learner_id' => 1,
    'from_date' => '2023-06-01',
    'to_date' => '2023-06-14'
];
const API_USERNAME = getenv('API_USERNAME'); // Assuming you have these environment variables set
const API_PASSWORD = getenv('API_PASSWORD');

$curl = curl_init();

$query = http_build_query(PARAMS);

$options = [
    CURLOPT_URL => BASE_URL . '/' . SCHOOL_LOGIN_ID . '?' . $query,
    CURLOPT_RETURNTRANSFER => true,
    CURLOPT_SSL_VERIFYPEER => true,
    CURLOPT_CUSTOMREQUEST => 'GET',
    CURLOPT_HTTPHEADER => [
        "HTTP-X-USERNAME: " . API_USERNAME,
        "HTTP-X-PASSWORD: " . API_PASSWORD
    ],
];

curl_setopt_array($curl, $options);

$response = curl_exec($curl);

if (curl_errno($curl)) {
    throw new Exception('Curl error: ' . curl_error($curl));
}

curl_close($curl);

echo $response;
```

{% endtab %}

{% tab title="cURL" %}

```bash
curl --location 'https://integrate.d6plus.co.za/api/v1/adminplus/learnerabsentees/1000?learner_id=1&from_date=2023-06-01&to_date=2023-06-14' \
--header 'HTTP-X-USERNAME: your_username' \
--header 'HTTP-X-PASSWORD: your_password'
```

{% endtab %}
{% endtabs %}


# Get Learner Discipline

## Get learner discipline records

<mark style="color:blue;">`GET`</mark> `https://integrate.d6plus.co.za/api/v1/adminplus/learnerdiscipline/{school_login_id}`

Use this endpoint to fetch discipline records for one or more learners for the specified school.  By default, all discipline records for the last month will be returned, regardless of the associated learners current status.&#x20;

It is possible to retrieve discipline records for a single learner by providing the optional `learner_id` query parameter.

It is possible to specify a different date range by providing the optional `from_date` and `to_date` query parameters. \
The following validation applies:\
\- The `to_date` may not be before the `from_date`. \
\- The date range may not span more than 31 days.

#### Path Parameters

| Name                                                | Type    | Description                                      |
| --------------------------------------------------- | ------- | ------------------------------------------------ |
| school\_login\_id<mark style="color:red;">\*</mark> | Integer | The login ID of the school to retrieve data from |

#### Query Parameters

| Name        | Type    | Description                           |
| ----------- | ------- | ------------------------------------- |
| learner\_id | Integer | The ID of a specific learner          |
| to\_date    | String  | Range end date in format YYYY-MM-DD   |
| from\_date  | String  | Range start date in format YYYY-MM-DD |

#### Headers

| Name                                              | Type   | Description       |
| ------------------------------------------------- | ------ | ----------------- |
| HTTP-X-USERNAME<mark style="color:red;">\*</mark> | String | As provided by d6 |
| HTTP-X-PASSWORD<mark style="color:red;">\*</mark> | String | As provided by d6 |

{% tabs %}
{% tab title="200 The request was successful." %}

```json
[
    {
        "id": "1",
        "learner_id": "2",
        "discipline_date": "2023-06-30",
        "discipline_category": "Level 1",
        "discipline_reason": "Appearance : Hair / Nails",
        "discipline_points": "-1",
        "discipline_remarks": "",
        "staff_member_id": "3"
    },
    {
        "id": "2",
        "learner_id": "1",
        "discipline_date": "2023-07-03",
        "discipline_category": "General",
        "discipline_reason": "Handed in lost goods/money",
        "discipline_points": "3",
        "discipline_remarks": "",
        "staff_member_id": "4"
    }
]
```

{% endtab %}

{% tab title="404: Not Found The resource was not found." %}

```json
{
    "error": "Not found",
    "error_description": "No learner discipline records found"
}
```

{% endtab %}

{% tab title="401: Unauthorized The server understood the request, but is refusing it or access is not allowed." %}

```json
{
    "error": "Unauthorized",
    "error_description": "Client access not authorised"
}
```

{% endtab %}

{% tab title="400: Bad Request The request was invalid. Normally due to missing or malformed parameters." %}

```json
{
    "error": "Bad Request",
    "error_description": "The specified date range may not be more than 31 days"
}
```

{% endtab %}

{% tab title="403: Forbidden The server understood the request, but the requested action is not allowed." %}

```json
{
    "error": "Integration not activated",
    "error_description": "Please activate the Admin+ API for this client before making this request"
}
```

{% endtab %}
{% endtabs %}

## Examples

{% tabs %}
{% tab title="PHP" %}

```php
<?php

const BASE_URL = 'https://integrate.d6plus.co.za/api/v1/adminplus/learnerdiscipline';
const SCHOOL_LOGIN_ID = '1000';
const PARAMS = [
    'learner_id' => 1,
    'from_date' => '2023-06-01',
    'to_date' => '2023-06-14'
];
const API_USERNAME = getenv('API_USERNAME'); // Assuming you have these environment variables set
const API_PASSWORD = getenv('API_PASSWORD');

$curl = curl_init();

$query = http_build_query(PARAMS);

$options = [
    CURLOPT_URL => BASE_URL . '/' . SCHOOL_LOGIN_ID . '?' . $query,
    CURLOPT_RETURNTRANSFER => true,
    CURLOPT_SSL_VERIFYPEER => true,
    CURLOPT_CUSTOMREQUEST => 'GET',
    CURLOPT_HTTPHEADER => [
        "HTTP-X-USERNAME: " . API_USERNAME,
        "HTTP-X-PASSWORD: " . API_PASSWORD
    ],
];

curl_setopt_array($curl, $options);

$response = curl_exec($curl);

if (curl_errno($curl)) {
    throw new Exception('Curl error: ' . curl_error($curl));
}

curl_close($curl);

echo $response;
```

{% endtab %}

{% tab title="cURL" %}

```bash
curl --location 'https://integrate.d6plus.co.za/api/v1/adminplus/learnerdiscipline/1000?learner_id=1&from_date=2023-06-01&to_date=2023-06-14' \
--header 'HTTP-X-USERNAME: your_username' \
--header 'HTTP-X-PASSWORD: your_password'
```

{% endtab %}
{% endtabs %}


# Parent


# Get Parent(s)

## Get one or more parent records

<mark style="color:blue;">`GET`</mark> `https://integrate.d6plus.co.za/api/v1/adminplus/parents/{school_login_id}`

Use this endpoint to fetch one or more parent records for the specified school.  By default, parents of all current active learners will be returned.&#x20;

It is possible to retrieve a single parent by providing the optional `parent_id` query parameter.

#### Path Parameters

| Name                                                | Type    | Description                                      |
| --------------------------------------------------- | ------- | ------------------------------------------------ |
| school\_login\_id<mark style="color:red;">\*</mark> | Integer | The login ID of the school to retrieve data from |

#### Query Parameters

| Name       | Type    | Description                 |
| ---------- | ------- | --------------------------- |
| parent\_id | Integer | The ID of a specific parent |

#### Headers

| Name                                              | Type   | Description       |
| ------------------------------------------------- | ------ | ----------------- |
| HTTP-X-USERNAME<mark style="color:red;">\*</mark> | String | As provided by d6 |
| HTTP-X-PASSWORD<mark style="color:red;">\*</mark> | String | As provided by d6 |

{% tabs %}
{% tab title="200 The request was successful." %}

```json
[
    {
        "id": "40",
        "title": "Mr",
        "first_name": "John James",
        "last_name": "Smith",
        "mobile_calling_code": "27",
        "mobile_number": "0823456789",
        "email_address": "jjsmith@example.com",
        "date_of_birth": "1967-02-14",
        "gender": "M",
        "ethnic_group_id": "4",
        "ethnic_group": "White",
        "residential_address": "Plot 101\r\nDaffodil Street\r\nPretoria",
        "postal_address": "PO Box 12\r\nMenlyn\r\nPretoria",
        "home_language_id": "2",
        "home_language": "English",
        "nationality": "South Africa",
        "family_code": "1001",
        "id_number": "6702145076084",
        "passport_number": "A0176543",
        "marital_status_id": "2",
        "marital_status": "Married",
        "occupation_status": "Full Time Employed",
        "occupation": "Salesman",
        "employment_sector": "Selling",
        "gross_annual_income": "120000.00"
    },
    {
        "id": "41",
        "title": "Mrs",
        "first_name": "Jane Jenny",
        "last_name": "Smith",
        "mobile_calling_code": "27",
        "mobile_number": "0798765432",
        "email_address": "smith.jj@example.org",
        "date_of_birth": "1955-06-17",
        "gender": "F",
        "ethnic_group_id": "1",
        "ethnic_group": "African/Black",
        "residential_address": "Plot 101\r\nDaffodil Street\r\nPretoria",
        "postal_address": "PO Box 12\r\nMenlyn\r\nPretoria",
        "home_language_id": "2",
        "home_language": "English",
        "nationality": "South Africa",
        "family_code": "1001",
        "id_number": "5506170079082",
        "passport_number": "",
        "marital_status_id": "2",
        "marital_status": "Married",
        "occupation_status": "Unemployed",
        "occupation": "",
        "employment_sector": "Other",
        "gross_annual_income": "0.00"
    }
]
```

{% endtab %}

{% tab title="404: Not Found The resource was not found." %}

```json
{
    "error": "Not found",
    "error_description": "No parent records found"
}
```

{% endtab %}

{% tab title="401: Unauthorized The server understood the request, but is refusing it or access is not allowed." %}

```json
{
    "error": "Unauthorized",
    "error_description": "Client access not authorised"
}
```

{% endtab %}

{% tab title="403: Forbidden The server understood the request, but the requested action is not allowed." %}

```json
{
    "error": "Integration not activated",
    "error_description": "Please activate the Admin+ API for this client before making this request"
}
```

{% endtab %}
{% endtabs %}

## Examples

{% tabs %}
{% tab title="PHP" %}

```php
<?php

const BASE_URL = 'https://integrate.d6plus.co.za/api/v1/adminplus/parents';
const SCHOOL_LOGIN_ID = '1000';
const PARAMS = ['parent_id' => 1];
const API_USERNAME = getenv('API_USERNAME'); // Assuming you have these environment variables set
const API_PASSWORD = getenv('API_PASSWORD');

$curl = curl_init();

$query = http_build_query(PARAMS);

$options = [
    CURLOPT_URL => BASE_URL . '/' . SCHOOL_LOGIN_ID . '?' . $query,
    CURLOPT_RETURNTRANSFER => true,
    CURLOPT_SSL_VERIFYPEER => true,
    CURLOPT_CUSTOMREQUEST => 'GET',
    CURLOPT_HTTPHEADER => [
        "HTTP-X-USERNAME: " . API_USERNAME,
        "HTTP-X-PASSWORD: " . API_PASSWORD
    ],
];

curl_setopt_array($curl, $options);

$response = curl_exec($curl);

if (curl_errno($curl)) {
    throw new Exception('Curl error: ' . curl_error($curl));
}

curl_close($curl);

echo $response;
```

{% endtab %}

{% tab title="cURL" %}

```bash
curl --location 'https://integrate.d6plus.co.za/api/v1/adminplus/parents/1000?parent_id=1' \
--header 'HTTP-X-USERNAME: your_username' \
--header 'HTTP-X-PASSWORD: your_password'
```

{% endtab %}
{% endtabs %}


# Staff Member


# Get Staff Member(s)

## Get one or more staff member records

<mark style="color:blue;">`GET`</mark> `https://integrate.d6plus.co.za/api/v1/adminplus/staffmembers/{school_login_id}`

Use this endpoint to fetch one or more staff member records for the specified school.  By default all current active staff members will be returned.&#x20;

It is possible to retrieve a single staff member by providing the optional `staff_member_id` query parameter.

#### Path Parameters

| Name                                                | Type    | Description                                      |
| --------------------------------------------------- | ------- | ------------------------------------------------ |
| school\_login\_id<mark style="color:red;">\*</mark> | Integer | The login ID of the school to retrieve data from |

#### Query Parameters

| Name              | Type    | Description                       |
| ----------------- | ------- | --------------------------------- |
| staff\_member\_id | Integer | The ID of a specific staff member |

#### Headers

| Name                                              | Type   | Description       |
| ------------------------------------------------- | ------ | ----------------- |
| HTTP-X-USERNAME<mark style="color:red;">\*</mark> | String | As provided by d6 |
| HTTP-X-PASSWORD<mark style="color:red;">\*</mark> | String | As provided by d6 |

{% tabs %}
{% tab title="200 The request was successful." %}

```json
[
    {
        "id": "1",
        "title": "Mr",
        "first_name": "John",
        "last_name": "Smith",
        "mobile_calling_code": "27",
        "mobile_number": "0823456789",
        "email_address": "jjsmith@example.com",
        "date_of_birth": "1967-02-14",
        "gender": "M",
        "ethnic_group": "White",
        "residential_address": "Plot 101\r\nDaffodil Street\r\nPretoria",
        "postal_address": "PO Box 12\r\nMenlyn\r\nPretoria",
        "home_language": "English",
        "nationality": "South Africa",
        "id_number": "6702145076084",
        "passport_number": "A0176543",
        "marital_status_id": "Married",
        "employment_category": "Finance",
        "is_educator": "Yes",
        "appointment_type": "Temporary",
        "paid_by": "Department of Education",
        "sace_number": "123456",
        "register_classes": "2A"
    },
    {
        "id": "2",
        "title": "Mrs",
        "first_name": "Jane",
        "last_name": "Smith",
        "mobile_calling_code": "27",
        "mobile_number": "0798765432",
        "email_address": "smith.jj@example.org",
        "date_of_birth": "1955-06-17",
        "gender": "F",
        "ethnic_group": "African/Black",
        "residential_address": "Plot 101\r\nDaffodil Street\r\nPretoria",
        "postal_address": "PO Box 12\r\nMenlyn\r\nPretoria",
        "home_language": "English",
        "nationality": "South Africa",
        "id_number": "5506170079082",
        "passport_number": "",
        "marital_status_id": "Married",
        "employment_category": "Head Of Department",
        "is_educator": "No",
        "appointment_type": "Permanent",
        "paid_by": "Governing Body",
        "sace_number": "234567",
        "register_classes": "1A,2B,5A"
    }
]
```

{% endtab %}

{% tab title="404: Not Found The resource was not found." %}

```json
{
    "error": "Not found",
    "error_description": "No staff member records found"
}
```

{% endtab %}

{% tab title="401: Unauthorized The server understood the request, but is refusing it or access is not allowed." %}

```json
{
    "error": "Unauthorized",
    "error_description": "Client access not authorised"
}
```

{% endtab %}

{% tab title="403: Forbidden The server understood the request, but the requested action is not allowed." %}

```json
{
    "error": "Integration not activated",
    "error_description": "Please activate the Admin+ API for this client before making this request"
}
```

{% endtab %}
{% endtabs %}

## Examples

{% tabs %}
{% tab title="PHP" %}

```php
<?php

const BASE_URL = 'https://integrate.d6plus.co.za/api/v1/adminplus/staffmembers';
const SCHOOL_LOGIN_ID = '1000';
const PARAMS = ['staff_member_id' => 1];
const API_USERNAME = getenv('API_USERNAME'); // Assuming you have these environment variables set
const API_PASSWORD = getenv('API_PASSWORD');

$curl = curl_init();

$query = http_build_query(PARAMS);

$options = [
    CURLOPT_URL => BASE_URL . '/' . SCHOOL_LOGIN_ID . '?' . $query,
    CURLOPT_RETURNTRANSFER => true,
    CURLOPT_SSL_VERIFYPEER => true,
    CURLOPT_CUSTOMREQUEST => 'GET',
    CURLOPT_HTTPHEADER => [
        "HTTP-X-USERNAME: " . API_USERNAME,
        "HTTP-X-PASSWORD: " . API_PASSWORD
    ],
];

curl_setopt_array($curl, $options);

$response = curl_exec($curl);

if (curl_errno($curl)) {
    throw new Exception('Curl error: ' . curl_error($curl));
}

curl_close($curl);

echo $response;
```

{% endtab %}

{% tab title="cURL" %}

```bash
curl --location 'https://integrate.d6plus.co.za/api/v1/adminplus/staffmembers/1000?staff_member_id=1' \
--header 'HTTP-X-USERNAME: your_username' \
--header 'HTTP-X-PASSWORD: your_password'
```

{% endtab %}
{% endtabs %}


# Curriculum+

This section details the REST endpoints to interact with the Curriculum+ module.

## Endpoint

The base URL for all endpoints in this module is shown below. The version number is independent per endpoint.

`https://integrate.d6plus.co.za/api/v1/`**`currplus`**`/`


# Learner


# Get Learner Subjects

## Get the subject records for one or more learners

<mark style="color:blue;">`GET`</mark> `https://integrate.d6plus.co.za/api/v1/currplus/learnersubjects/{school_login_id}`

Use this endpoint to fetch the list of subjects for the current year for one or more learner for the specified school.  By default, the subjects for all current active learners will be returned.&#x20;

It is possible to retrieve the subjects for a single learner by providing the optional `learner_id` query parameter.

#### Path Parameters

| Name                                                | Type    | Description                                      |
| --------------------------------------------------- | ------- | ------------------------------------------------ |
| school\_login\_id<mark style="color:red;">\*</mark> | Integer | The login ID of the school to retrieve data from |

#### Query Parameters

| Name        | Type    | Description                  |
| ----------- | ------- | ---------------------------- |
| learner\_id | Integer | The ID of a specific learner |

#### Headers

| Name                                              | Type   | Description       |
| ------------------------------------------------- | ------ | ----------------- |
| HTTP-X-USERNAME<mark style="color:red;">\*</mark> | String | As provided by d6 |
| HTTP-X-PASSWORD<mark style="color:red;">\*</mark> | String | As provided by d6 |

{% tabs %}
{% tab title="200 The request was successful." %}

```json
[
    {
        "learner_id": "1",
        "first_name": "Janey",
        "last_name": "Smith",
        "subject_id": 101,
        "subject_name": "Afrikaans Home Language (Gr 05)"
    },
    {
        "learner_id": "1",
        "first_name": "Janey",
        "last_name": "Smith",
        "subject_id": 105,        
        "subject_name": "English First Additional Language (Gr 05)"
    },
    {
        "learner_id": "1",
        "first_name": "Janey",
        "last_name": "Smith",
        "subject_id": 201,        
        "subject_name": "Life Skills (Gr 05)"
    },
    {
        "learner_id": "1",
        "first_name": "Janey",
        "last_name": "Smith",
        "subject_id": 135,        
        "subject_name": "Mathematics (Gr 05)"
    },
    {
        "learner_id": "1",
        "first_name": "Janey",
        "last_name": "Smith",
        "subject_id": 322,
        "subject_name": "Natural Sciences and Technology (Gr 05)"
    },
    {
        "learner_id": "1",
        "first_name": "Janey",
        "last_name": "Smith",
        "subject_id": 49,        
        "subject_name": "Social Sciences (Gr 05)"
    }
]
```

{% endtab %}

{% tab title="404: Not Found The resource was not found." %}

```json
{
    "error": "Not found",
    "error_description": "No learner subject records found"
}
```

{% endtab %}

{% tab title="401: Unauthorized The server understood the request, but is refusing it or access is not allowed." %}

```json
{
    "error": "Unauthorized",
    "error_description": "Client access not authorised"
}
```

{% endtab %}

{% tab title="403: Forbidden The server understood the request, but the requested action is not allowed." %}

```json
{
    "error": "Integration not activated",
    "error_description": "Please activate the Curriculum+ API for this client before making this request"
}
```

{% endtab %}
{% endtabs %}

## Examples

{% tabs %}
{% tab title="PHP" %}

```php
<?php

const BASE_URL = 'https://integrate.d6plus.co.za/api/v1/currplus/learnersubjects';
const SCHOOL_LOGIN_ID = '1000';
const PARAMS = ['learner_id' => 1];
const API_USERNAME = getenv('API_USERNAME'); // Assuming you have these environment variables set
const API_PASSWORD = getenv('API_PASSWORD');

$curl = curl_init();

$query = http_build_query(PARAMS);

$options = [
    CURLOPT_URL => BASE_URL . '/' . SCHOOL_LOGIN_ID . '?' . $query,
    CURLOPT_RETURNTRANSFER => true,
    CURLOPT_SSL_VERIFYPEER => true,
    CURLOPT_CUSTOMREQUEST => 'GET',
    CURLOPT_HTTPHEADER => [
        "HTTP-X-USERNAME: " . API_USERNAME,
        "HTTP-X-PASSWORD: " . API_PASSWORD
    ],
];

curl_setopt_array($curl, $options);

$response = curl_exec($curl);

if (curl_errno($curl)) {
    throw new Exception('Curl error: ' . curl_error($curl));
}

curl_close($curl);

echo $response;
```

{% endtab %}

{% tab title="cURL" %}

```bash
curl --location 'https://integrate.d6plus.co.za/api/v1/currplus/learnersubjects/1000?learner_id=1' \
--header 'HTTP-X-USERNAME: your_username' \
--header 'HTTP-X-PASSWORD: your_password'
```

{% endtab %}
{% endtabs %}


# Get Learner Subjects Per Term

## Get the subject records for a learner per term

<mark style="color:blue;">`GET`</mark> `https://integrate.d6plus.co.za/api/v1/currplus/learnersubjectsperterm/{school_login_id}`

Use this endpoint to fetch the subjects per term for the specified learner, for the specified school.  \
All subjects for all terms will be return, for the current d6+ administrative year. \
The results are grouped per term, per subject, for the current administrative year.&#x20;

#### Path Parameters

| Name                                                | Type    | Description                                      |
| --------------------------------------------------- | ------- | ------------------------------------------------ |
| school\_login\_id<mark style="color:red;">\*</mark> | Integer | The login ID of the school to retrieve data from |

#### Query Parameters

| Name                                          | Type    | Description                  |
| --------------------------------------------- | ------- | ---------------------------- |
| learner\_id<mark style="color:red;">\*</mark> | Integer | The ID of a specific learner |

#### Headers

| Name                                              | Type   | Description       |
| ------------------------------------------------- | ------ | ----------------- |
| HTTP-X-USERNAME<mark style="color:red;">\*</mark> | String | As provided by d6 |
| HTTP-X-PASSWORD<mark style="color:red;">\*</mark> | String | As provided by d6 |

{% tabs %}
{% tab title="200 The request was successful." %}

```json
[
    {
        "year": "2025",
        "subject_id": "10",
        "subject_name": "Afrikaans First Additional Language (Gr 07)",
        "super_subject_id": "1",
        "super_subject_name": "Afrikaans First Additional Language",
        "grade_id": "9",
        "grade": "7",
        "terms": [
            {
                "term_id": 98,
                "term": "1",
                "subject_group_id": "118",
                "subject_group_name": "Afrikaans Group 1",
                "classroom_id": "1",
                "classroom_name": "1",
                "subject_group_teacher_id": "13"
            },
            {
                "term_id": 99,
                "term": "2",
                "subject_group_id": "118",
                "subject_group_name": "Afrikaans Group 1",
                "classroom_id": "1",
                "classroom_name": "1",
                "subject_group_teacher_id": "13"
            },
            {
                "term_id": 100,
                "term": "3",
                "subject_group_id": "270",
                "subject_group_name": "Afrikaans Group 2",
                "classroom_id": "4",
                "classroom_name": "3A",
                "subject_group_teacher_id": "17"
            },
            {
                "term_id": 101,
                "term": "4",
                "subject_group_id": "270",
                "subject_group_name": "Afrikaans Group 2",
                "classroom_id": "4",
                "classroom_name": "3A",
                "subject_group_teacher_id": "17"
            }
        ]
    },
    {
        "year": "2025",
        "subject_id": "3418",
        "subject_name": "Coding and Robotics (Gr 07)",
        "super_subject_id": "2334",
        "super_subject_name": "Coding and Robotics",
        "grade_id": "9",
        "grade": "7",
        "terms": [
            {
                "term_id": 98,
                "term": "1",
                "subject_group_id": "119",
                "subject_group_name": "Coding 1A",
                "classroom_id": "2",
                "classroom_name": "2",
                "subject_group_teacher_id": "4"
            },
            {
                "term_id": 99,
                "term": "2",
                "subject_group_id": "119",
                "subject_group_name": "Coding 1A",
                "classroom_id": "2",
                "classroom_name": "2",
                "subject_group_teacher_id": "4"
            },
            {
                "term_id": 100,
                "term": "3",
                "subject_group_id": "322",
                "subject_group_name": "Coding 1B",
                "classroom_id": "9",
                "classroom_name": "K4",
                "subject_group_teacher_id": "17"
            },
            {
                "term_id": 101,
                "term": "4",
                "subject_group_id": "322",
                "subject_group_name": "Coding 1B",
                "classroom_id": "9",
                "classroom_name": "K4",
                "subject_group_teacher_id": "17"
            }
        ]
    }
]
```

{% endtab %}

{% tab title="404: Not Found The resource was not found." %}

```json
{
    "error": "Not found",
    "error_description": "No learner subject records found"
}
```

{% endtab %}

{% tab title="401: Unauthorized The server understood the request, but is refusing it or access is not allowed." %}

```json
{
    "error": "Unauthorized",
    "error_description": "Client access not authorised"
}
```

{% endtab %}

{% tab title="403: Forbidden The server understood the request, but the requested action is not allowed." %}

```json
{
    "error": "Integration not activated",
    "error_description": "Please activate the Curriculum+ API for this client before making this request"
}
```

{% endtab %}

{% tab title="400: Bad Request The server understood the request, but the request is invalid or malformed." %}

```json
{
    "error": "Bad Request",
    "error_description": "Please specify the learner_id request parameter."
}
```

{% endtab %}
{% endtabs %}

## Examples

{% tabs %}
{% tab title="PHP" %}

```php
<?php

const BASE_URL = 'https://integrate.d6plus.co.za/api/v1/currplus/learnersubjectsperterm';
const SCHOOL_LOGIN_ID = '1000';
const PARAMS = ['learner_id' => 1];
const API_USERNAME = getenv('API_USERNAME'); // Assuming you have these environment variables set
const API_PASSWORD = getenv('API_PASSWORD');

$curl = curl_init();

$query = http_build_query(PARAMS);

$options = [
    CURLOPT_URL => BASE_URL . '/' . SCHOOL_LOGIN_ID . '?' . $query,
    CURLOPT_RETURNTRANSFER => true,
    CURLOPT_SSL_VERIFYPEER => true,
    CURLOPT_CUSTOMREQUEST => 'GET',
    CURLOPT_HTTPHEADER => [
        "HTTP-X-USERNAME: " . API_USERNAME,
        "HTTP-X-PASSWORD: " . API_PASSWORD
    ],
];

curl_setopt_array($curl, $options);

$response = curl_exec($curl);

if (curl_errno($curl)) {
    throw new Exception('Curl error: ' . curl_error($curl));
}

curl_close($curl);

echo $response;
```

{% endtab %}

{% tab title="cURL" %}

```bash
curl --location 'https://integrate.d6plus.co.za/api/v1/currplus/learnersubjectsperterm/1000?learner_id=1' \
--header 'HTTP-X-USERNAME: your_username' \
--header 'HTTP-X-PASSWORD: your_password'
```

{% endtab %}
{% endtabs %}


# Get Learner Subject Marks

## Get the subject marks records for a learner

<mark style="color:blue;">`GET`</mark> `https://integrate.d6plus.co.za/api/v1/currplus/learnersubjectmarks/{school_login_id}`

Use this endpoint to fetch the marks for the specified learner, for the specified school.  \
All marks for all terms will be return, for the current d6+ administrative year. \
The results are grouped per term, per subject, for the current administrative year.&#x20;

#### Path Parameters

| Name                                                | Type    | Description                                      |
| --------------------------------------------------- | ------- | ------------------------------------------------ |
| school\_login\_id<mark style="color:red;">\*</mark> | Integer | The login ID of the school to retrieve data from |

#### Query Parameters

| Name                                          | Type    | Description                  |
| --------------------------------------------- | ------- | ---------------------------- |
| learner\_id<mark style="color:red;">\*</mark> | Integer | The ID of a specific learner |

#### Headers

| Name                                              | Type   | Description       |
| ------------------------------------------------- | ------ | ----------------- |
| HTTP-X-USERNAME<mark style="color:red;">\*</mark> | String | As provided by d6 |
| HTTP-X-PASSWORD<mark style="color:red;">\*</mark> | String | As provided by d6 |

{% tabs %}
{% tab title="200 The request was successful." %}

```json
[
    {
        "year": "2023",
        "subject_id": "21",
        "subject_name": "Afrikaans Home Language (Gr 05)",
        "grade_id": "7",
        "grade": "5",
        "terms": [
            {
                "term": "1",
                "mark": "80.00"
            },
            {
                "term": "2",
                "mark": "72.86"
            }
        ]
    },
    {
        "year": "2023",
        "subject_id": "105",
        "subject_name": "English First Additional Language (Gr 05)",
        "grade_id": "7",
        "grade": "5",
        "terms": [
            {
                "term": "1",
                "mark": "70.00"
            },
            {
                "term": "2",
                "mark": "77.14"
            }
        ]
    },
    {
        "year": "2023",
        "subject_id": "314",
        "subject_name": "Life Skills (Gr 05)",
        "grade_id": "7",
        "grade": "5",
        "terms": [
            {
                "term": "1",
                "mark": "60.00"
            },
            {
                "term": "2",
                "mark": "96.00"
            }
        ]
    },
    {
        "year": "2023",
        "subject_id": "327",
        "subject_name": "Mathematics (Gr 05)",
        "grade_id": "7",
        "grade": "5",
        "terms": [
            {
                "term": "1",
                "mark": "75.00"
            },
            {
                "term": "2",
                "mark": "96.00"
            }
        ]
    },
    {
        "year": "2023",
        "subject_id": "355",
        "subject_name": "Natural Sciences and Technology (Gr 05)",
        "grade_id": "7",
        "grade": "5",
        "terms": [
            {
                "term": "1",
                "mark": "65.00"
            },
            {
                "term": "2",
                "mark": "88.33"
            }
        ]
    },
    {
        "year": "2023",
        "subject_id": "533",
        "subject_name": "Social Sciences (Gr 05)",
        "grade_id": "7",
        "grade": "5",
        "terms": [
            {
                "term": "1",
                "mark": "85.00"
            },
            {
                "term": "2",
                "mark": "90.00"
            }
        ]
    }
]
```

{% endtab %}

{% tab title="404: Not Found The resource was not found." %}

```json
{
    "error": "Not found",
    "error_description": "No subject mark records found"
}
```

{% endtab %}

{% tab title="401: Unauthorized The server understood the request, but is refusing it or access is not allowed." %}

```json
{
    "error": "Unauthorized",
    "error_description": "Client access not authorised"
}
```

{% endtab %}

{% tab title="403: Forbidden The server understood the request, but the requested action is not allowed." %}

```json
{
    "error": "Integration not activated",
    "error_description": "Please activate the Curriculum+ API for this client before making this request"
}
```

{% endtab %}

{% tab title="400: Bad Request The server understood the request, but the request is invalid or malformed." %}

```json
{
    "error": "Bad Request",
    "error_description": "Please specify the learner_id request parameter."
}
```

{% endtab %}
{% endtabs %}

## Examples

{% tabs %}
{% tab title="PHP" %}

```php
<?php

const BASE_URL = 'https://integrate.d6plus.co.za/api/v1/currplus/learnersubjectmarks';
const SCHOOL_LOGIN_ID = '1000';
const PARAMS = ['learner_id' => 1];
const API_USERNAME = getenv('API_USERNAME'); // Assuming you have these environment variables set
const API_PASSWORD = getenv('API_PASSWORD');

$curl = curl_init();

$query = http_build_query(PARAMS);

$options = [
    CURLOPT_URL => BASE_URL . '/' . SCHOOL_LOGIN_ID . '?' . $query,
    CURLOPT_RETURNTRANSFER => true,
    CURLOPT_SSL_VERIFYPEER => true,
    CURLOPT_CUSTOMREQUEST => 'GET',
    CURLOPT_HTTPHEADER => [
        "HTTP-X-USERNAME: " . API_USERNAME,
        "HTTP-X-PASSWORD: " . API_PASSWORD
    ],
];

curl_setopt_array($curl, $options);

$response = curl_exec($curl);

if (curl_errno($curl)) {
    throw new Exception('Curl error: ' . curl_error($curl));
}

curl_close($curl);

echo $response;
```

{% endtab %}

{% tab title="cURL" %}

```bash
curl --location 'https://integrate.d6plus.co.za/api/v1/currplus/learnersubjectmarks/1000?learner_id=1' \
--header 'HTTP-X-USERNAME: your_username' \
--header 'HTTP-X-PASSWORD: your_password'
```

{% endtab %}
{% endtabs %}


# Get Learner Assessment Marks

### Get the assessment marks records for a learner or grade

<mark style="color:blue;">`GET`</mark> `https://integrate.d6plus.co.za/api/v1/currplus/learnerassessmentmarks/{school_login_id}`

Use this endpoint to fetch the individual assessment marks for the specified learner or grade, for the specified school.\
The results are grouped per grade, per year, per term, per learner, per subject, per learning outcome, with the assessments listed under each learning outcome.\
At least one of the `learner_id` or `grade_id` query parameters must be provided. If no `year` is provided, the current d6+ administrative year is used.\
Assessment marks are only included once the marks for the learning program have been released (the learning program's mark release date, or the end of the term if no release date is set). Use the `structure` parameter to retrieve the assessment structure (assessments, dates and weights) without any marks.

**Path Parameters**

| Name                                                | Type    | Description                                      |
| --------------------------------------------------- | ------- | ------------------------------------------------ |
| school\_login\_id<mark style="color:red;">\*</mark> | Integer | The login ID of the school to retrieve data from |

**Query Parameters**

| Name                  | Type    | Description                                                                              |
| --------------------- | ------- | ---------------------------------------------------------------------------------------- |
| learner\_id           | Integer | The ID of a specific learner. Required if `grade_id` is not provided                     |
| grade\_id             | Integer | The ID of a specific grade. Required if `learner_id` is not provided                     |
| subject\_id           | Integer | Only return marks for the specified subject                                              |
| year                  | Integer | The administrative year to return marks for. Defaults to the current administrative year |
| term                  | Integer | Only return marks for the specified term                                                 |
| learning\_outcome\_id | Integer | Only return marks for the specified learning outcome                                     |
| assessment\_id        | Integer | Only return marks for the specified assessment                                           |
| structure             | Boolean | When set to 1, only the assessment structure is returned, without any marks              |

**Headers**

| Name                                              | Type   | Description       |
| ------------------------------------------------- | ------ | ----------------- |
| HTTP-X-USERNAME<mark style="color:red;">\*</mark> | String | As provided by d6 |
| HTTP-X-PASSWORD<mark style="color:red;">\*</mark> | String | As provided by d6 |

{% tabs %}
{% tab title="200 The request was successful." %}

```json
{
    "7": {
        "grade": "5",
        "years": {
            "2026": {
                "year": "2026",
                "year_name": "2026",
                "terms": {
                    "1": {
                        "term": "1",
                        "learners": {
                            "1": {
                                "learner_id": "1",
                                "subjects": {
                                    "327": {
                                        "subject_id": "327",
                                        "subject_name": "Mathematics (Gr 05)",
                                        "learning_outcomes": {
                                            "12": {
                                                "learning_outcome_id": "12",
                                                "learning_outcome_name": "Numbers, Operations and Relationships",
                                                "assessments": {
                                                    "45": {
                                                        "assessment_id": "45",
                                                        "assessment_name": "Test 1",
                                                        "assessment_date": "2026-03-15",
                                                        "weight": "40.00",
                                                        "dtime": "2026-03-20 10:15:00",
                                                        "percentage": "75.00",
                                                        "mark": "30.00",
                                                        "mark_out_of": "40.00",
                                                        "captured": "1"
                                                    },
                                                    "46": {
                                                        "assessment_id": "46",
                                                        "assessment_name": "Assignment 1",
                                                        "assessment_date": "2026-02-20",
                                                        "weight": "60.00",
                                                        "dtime": "2026-02-25 08:30:00",
                                                        "percentage": "82.50",
                                                        "mark": "33.00",
                                                        "mark_out_of": "40.00",
                                                        "captured": "1"
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }
}
```

Notes on the assessment fields:

* `percentage` contains the value `"a"` when the learner was marked as absent for the assessment.
* `captured` indicates whether a mark has been captured for the assessment (`1`) or not (`0`).
* `dtime` is the date and time the mark was last updated.
* When the `structure` parameter is used, only `assessment_id`, `assessment_name`, `assessment_date` and `weight` are returned per assessment.
  {% endtab %}

{% tab title="404: Not Found The resource was not found." %}

```json
{
    "error": "Not found",
    "error_description": "No subject mark records found"
}
```

{% endtab %}

{% tab title="401: Unauthorized The server understood the request, but is refusing it or access is not allowed." %}

```json
{
    "error": "Unauthorized",
    "error_description": "Client access not authorised"
}
```

{% endtab %}

{% tab title="403: Forbidden The server understood the request, but the requested action is not allowed." %}

```json
{
    "error": "Integration not activated",
    "error_description": "Please activate the Curriculum+ API for this client before making this request"
}
```

{% endtab %}

{% tab title="400: Bad Request The server understood the request, but the request is invalid or malformed." %}

```json
{
    "error": "Bad Request",
    "error_description": "Please specify the learner_id or grade_id request parameter."
}
```

{% endtab %}
{% endtabs %}

### Examples

{% tabs %}
{% tab title="PHP" %}

```php
<?php

const BASE_URL = 'https://integrate.d6plus.co.za/api/v1/currplus/learnerassessmentmarks';
const SCHOOL_LOGIN_ID = '1000';
const PARAMS = ['learner_id' => 1];
const API_USERNAME = getenv('API_USERNAME'); // Assuming you have these environment variables set
const API_PASSWORD = getenv('API_PASSWORD');

$curl = curl_init();

$query = http_build_query(PARAMS);

$options = [
    CURLOPT_URL => BASE_URL . '/' . SCHOOL_LOGIN_ID . '?' . $query,
    CURLOPT_RETURNTRANSFER => true,
    CURLOPT_SSL_VERIFYPEER => true,
    CURLOPT_CUSTOMREQUEST => 'GET',
    CURLOPT_HTTPHEADER => [
        "HTTP-X-USERNAME: " . API_USERNAME,
        "HTTP-X-PASSWORD: " . API_PASSWORD
    ],
];

curl_setopt_array($curl, $options);

$response = curl_exec($curl);

if (curl_errno($curl)) {
    throw new Exception('Curl error: ' . curl_error($curl));
}

curl_close($curl);

echo $response;
```

{% endtab %}

{% tab title="cURL" %}

```bash
curl --location 'https://integrate.d6plus.co.za/api/v1/currplus/learnerassessmentmarks/1000?learner_id=1' \
--header 'HTTP-X-USERNAME: your_username' \
--header 'HTTP-X-PASSWORD: your_password'
```

{% endtab %}
{% endtabs %}


# Get Learner Year Marks

### Get the year and promotion marks for learners

<mark style="color:blue;">`GET`</mark> `https://integrate.d6plus.co.za/api/v1/currplus/learneryearmarks/{school_login_id}`

Use this endpoint to fetch the year marks and promotion marks for the specified school, for the specified year.\
The results are grouped per mark type ("Promotion mark" and "Year mark"), per grade, per learner, per subject.\
Marks are based on each learner's latest term of enrolment for the year, for the learner's current subjects. Subjects excluded from report cards are not included.\
By default marks are returned for the CAPS curriculum. A different curriculum can be requested with the optional `curriculum_id` parameter.

**Path Parameters**

| Name                                                | Type    | Description                                      |
| --------------------------------------------------- | ------- | ------------------------------------------------ |
| school\_login\_id<mark style="color:red;">\*</mark> | Integer | The login ID of the school to retrieve data from |

**Query Parameters**

| Name                                   | Type    | Description                                               |
| -------------------------------------- | ------- | --------------------------------------------------------- |
| year<mark style="color:red;">\*</mark> | Integer | The administrative year to return marks for               |
| learner\_id                            | Integer | The ID of a specific learner                              |
| subject\_id                            | Integer | Only return marks for the specified subject               |
| curriculum\_id                         | Integer | The ID of the curriculum. Defaults to the CAPS curriculum |

**Headers**

| Name                                              | Type   | Description       |
| ------------------------------------------------- | ------ | ----------------- |
| HTTP-X-USERNAME<mark style="color:red;">\*</mark> | String | As provided by d6 |
| HTTP-X-PASSWORD<mark style="color:red;">\*</mark> | String | As provided by d6 |

{% tabs %}
{% tab title="200 The request was successful." %}

```json
[
    {
        "mark_type": "Promotion mark",
        "grades": {
            "7": {
                "grade_id": "7",
                "grade": "5",
                "learners": {
                    "1": {
                        "learner_id": "1",
                        "subjects": {
                            "327": {
                                "subject_id": "327",
                                "subject_name": "Mathematics (Gr 05)",
                                "moderated_percentage": "68.00",
                                "original_percentage": "72.00",
                                "was_moderated": "1",
                                "threshold": "35.00"
                            },
                            "105": {
                                "subject_id": "105",
                                "subject_name": "English First Additional Language (Gr 05)",
                                "moderated_percentage": "77.14",
                                "original_percentage": "77.14",
                                "was_moderated": "0",
                                "threshold": null
                            }
                        }
                    }
                }
            }
        }
    },
    {
        "mark_type": "Year mark",
        "grades": {
            "7": {
                "grade_id": "7",
                "grade": "5",
                "learners": {
                    "1": {
                        "learner_id": "1",
                        "subjects": {
                            "327": {
                                "subject_id": "327",
                                "subject_name": "Mathematics (Gr 05)",
                                "moderated_percentage": "70.50",
                                "original_percentage": "70.50",
                                "was_moderated": "0",
                                "threshold": null
                            }
                        }
                    }
                }
            }
        }
    }
]
```

Notes on the subject fields:

* `moderated_percentage` is the mark after moderation. If no moderation was applied, it is equal to `original_percentage`.
* `original_percentage` is the calculated mark before any moderation.
* `was_moderated` indicates whether the mark was moderated (`1`) or not (`0`).
* `threshold` is the moderation threshold configured for the subject's marks formula, if any.
  {% endtab %}

{% tab title="404: Not Found The resource was not found." %}

```json
{
    "error": "Not found",
    "error_description": "No subject mark records found"
}
```

{% endtab %}

{% tab title="401: Unauthorized The server understood the request, but is refusing it or access is not allowed." %}

```json
{
    "error": "Unauthorized",
    "error_description": "Client access not authorised"
}
```

{% endtab %}

{% tab title="403: Forbidden The server understood the request, but the requested action is not allowed." %}

```json
{
    "error": "Integration not activated",
    "error_description": "Please activate the Curriculum+ API for this client before making this request"
}
```

{% endtab %}

{% tab title="400: Bad Request The server understood the request, but the request is invalid or malformed." %}

```json
{
    "error": "Bad Request",
    "error_description": "Please specify the year request parameter."
}
```

{% endtab %}
{% endtabs %}

### Examples

{% tabs %}
{% tab title="PHP" %}

```php
<?php

const BASE_URL = 'https://integrate.d6plus.co.za/api/v1/currplus/learneryearmarks';
const SCHOOL_LOGIN_ID = '1000';
const PARAMS = ['year' => 2026, 'learner_id' => 1];
const API_USERNAME = getenv('API_USERNAME'); // Assuming you have these environment variables set
const API_PASSWORD = getenv('API_PASSWORD');

$curl = curl_init();

$query = http_build_query(PARAMS);

$options = [
    CURLOPT_URL => BASE_URL . '/' . SCHOOL_LOGIN_ID . '?' . $query,
    CURLOPT_RETURNTRANSFER => true,
    CURLOPT_SSL_VERIFYPEER => true,
    CURLOPT_CUSTOMREQUEST => 'GET',
    CURLOPT_HTTPHEADER => [
        "HTTP-X-USERNAME: " . API_USERNAME,
        "HTTP-X-PASSWORD: " . API_PASSWORD
    ],
];

[...]
